com.fasterxml.jackson.databind.ser.impl

## Class MapEntrySerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<Map.Entry<?,?>>
      - - com.fasterxml.jackson.databind.ser.impl.MapEntrySerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class MapEntrySerializer
    extends ContainerSerializer<Map.Entry<?,?>>
    implements ContextualSerializer

Since:
  2.5
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected PropertySerializerMap` `_dynamicValueSerializers` If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.
`protected JavaType` `_entryType`
`protected JsonSerializer<Object>` `_keySerializer` Key serializer to use, if it can be statically determined
`protected JavaType` `_keyType`
`protected BeanProperty` `_property` Map-valued property being serialized with this instance
`protected JsonSerializer<Object>` `_valueSerializer` Value serializer to use, if it can be statically determined
`protected JavaType` `_valueType`
`protected boolean` `_valueTypeIsStatic` Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)
`protected TypeSerializer` `_valueTypeSerializer` Type identifier serializer used for values, if any.

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
`` `MapEntrySerializer(JavaType type, JavaType keyType, JavaType valueType, boolean staticTyping, TypeSerializer vts, BeanProperty property)`
`protected` `MapEntrySerializer(MapEntrySerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> keySer, JsonSerializer<?> valueSer)`

### Method Summary

Methods
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)`
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
`ContainerSerializer<?>` `_withValueTypeSerializer(TypeSerializer vts)` Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
`boolean` `hasSingleElement(Map.Entry<?,?> value)` Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(SerializerProvider prov, Map.Entry<?,?> value)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(Map.Entry<?,?> value, JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`protected void` `serializeDynamic(Map.Entry<?,?> value, JsonGenerator jgen, SerializerProvider provider)`
`protected void` `serializeUsing(Map.Entry<?,?> value, JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> ser)` Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.
`void` `serializeWithType(Map.Entry<?,?> value, JsonGenerator gen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`MapEntrySerializer` `withResolved(BeanProperty property, JsonSerializer<?> keySerializer, JsonSerializer<?> valueSerializer)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, isEmpty, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`acceptJsonFormatVisitor, createObjectNode, createSchemaNode, createSchemaNode, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findPropertyFilter, getSchema, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _property

    protected final BeanProperty _property

Map-valued property being serialized with this instance

#### _valueTypeIsStatic

    protected final boolean _valueTypeIsStatic

Whether static types should be used for serialization of values or not (if not, dynamic runtime type is used)

#### _entryType

    protected final JavaType _entryType

#### _keyType

    protected final JavaType _keyType

#### _valueType

    protected final JavaType _valueType

#### _keySerializer

    protected JsonSerializer<Object> _keySerializer

Key serializer to use, if it can be statically determined

#### _valueSerializer

    protected JsonSerializer<Object> _valueSerializer

Value serializer to use, if it can be statically determined

#### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

Type identifier serializer used for values, if any.

#### _dynamicValueSerializers

    protected PropertySerializerMap _dynamicValueSerializers

If value type can not be statically determined, mapping from runtime value types to serializers are stored in this object.

### Constructor Detail

#### MapEntrySerializer

    public MapEntrySerializer(JavaType type,
                      JavaType keyType,
                      JavaType valueType,
                      boolean staticTyping,
                      TypeSerializer vts,
                      BeanProperty property)

#### MapEntrySerializer

    protected MapEntrySerializer(MapEntrySerializer src,
                      BeanProperty property,
                      TypeSerializer vts,
                      JsonSerializer<?> keySer,
                      JsonSerializer<?> valueSer)

### Method Detail

#### _withValueTypeSerializer

    public ContainerSerializer<?> _withValueTypeSerializer(TypeSerializer vts)

Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<Map.Entry<?,?>>`

#### withResolved

    public MapEntrySerializer withResolved(BeanProperty property,
                                  JsonSerializer<?> keySerializer,
                                  JsonSerializer<?> valueSerializer)

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                     BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### getContentType

    public JavaType getContentType()

Description copied from class: `ContainerSerializer`
Accessor for finding declared (static) element type for type this serializer is used for.

Specified by:
  `getContentType` in class `ContainerSerializer<Map.Entry<?,?>>`

#### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

Description copied from class: `ContainerSerializer`
Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

Specified by:
  `getContentSerializer` in class `ContainerSerializer<Map.Entry<?,?>>`

#### hasSingleElement

    public boolean hasSingleElement(Map.Entry<?,?> value)

Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Specified by:
  `hasSingleElement` in class `ContainerSerializer<Map.Entry<?,?>>`

#### isEmpty

    public boolean isEmpty(SerializerProvider prov,
                  Map.Entry<?,?> value)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<Map.Entry<?,?>>`

#### serialize

    public void serialize(Map.Entry<?,?> value,
                 JsonGenerator gen,
                 SerializerProvider provider)
                   throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `StdSerializer<Map.Entry<?,?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeWithType

    public void serializeWithType(Map.Entry<?,?> value,
                         JsonGenerator gen,
                         SerializerProvider provider,
                         TypeSerializer typeSer)
                           throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, gen);
      serialize(value, gen, provider);
      typeSer.writeTypeSuffixForScalar(value, gen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.

Overrides:
  `serializeWithType` in class `JsonSerializer<Map.Entry<?,?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`

#### serializeDynamic

    protected void serializeDynamic(Map.Entry<?,?> value,
                        JsonGenerator jgen,
                        SerializerProvider provider)
                             throws IOException

Throws:
  `IOException`

#### serializeUsing

    protected void serializeUsing(Map.Entry<?,?> value,
                      JsonGenerator jgen,
                      SerializerProvider provider,
                      JsonSerializer<Object> ser)
                           throws IOException,
                                  JsonGenerationException

Method called to serialize fields, when the value type is statically known, so that value serializer is passed and does not need to be fetched from provider.

Throws:
  `IOException`
  `JsonGenerationException`

#### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                            Class<?> type,
                                            SerializerProvider provider)
                                                       throws JsonMappingException

Throws:
  `JsonMappingException`

#### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                            JavaType type,
                                            SerializerProvider provider)
                                                       throws JsonMappingException

Throws:
  `JsonMappingException`